function frmMainLoaded()
	if(GetNumGuildMembers(1)==0) then
		if(warned==nil) then
			print("Elgoh: Recieving Guild Information");
			warned=1;
		end
	else
		for i = 1, GetNumGuildMembers(0), 1 do 
			name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
			if(name==UnitName("player")) then 
				playername=name;
				elgohrank=rankIndex;
				playerrealm=GetRealmName();
				playerguild=GetGuildInfo("player");
				if(showValues==nil) then showValues=0; end
				if(legend==nil) then legend="Chuck Norris"; end
				if(legend_short==nil) then legend_short="Chuck"; end
				btnHatfield:SetText(legend);
				edtLegend:SetText(legend);
				tinsert(UISpecialFrames,"frmMain");
				tinsert(UISpecialFrames,"frmOfficer");
				frmMain:RegisterForDrag("LeftButton");
				frmMain:UnregisterEvent("GUILD_ROSTER_UPDATE");
				frmOfficer:RegisterEvent("CHAT_MSG_ADDON");
				frmOfficer:RegisterEvent("CHAT_MSG_GUILD");
				frmOfficer:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
				frmOfficer:RegisterForDrag("LeftButton");
				RegisterAddonMessagePrefix("lgoh");
				RegisterAddonMessagePrefix("lgohv");
				--	UnitPopupButtons["ANOO_SVARS"] = {text="Naughty", dist=0}
				--	table.insert(UnitPopupMenus["RAID"], "ANOO_SVARS")
				--	table.insert(UnitPopupMenus["SELF"], "ANOO_SVARS")
				--	hooksecurefunc("UnitPopup_OnClick", naughty)
				DKPOnLoad();
				-- Version Print
				if(oldversion==nil) then oldversion="1"; end -- Fix a bug when comparing to oldversion=nil
				vers = GetAddOnMetadata("ELGoH", "X-Curse-Packaged-Version") 
				if((playername=="Taurast" or playername=="Blamwit" or playername=="Schrodinger" or playername=="Staboo") and playerrealm=="Khadgar") then vers="Working Copy"; end
				vers = string.sub(vers, 1);
				if(vers>oldversion or playername=="Taurast") then
					print("Elgoh has been updated to "..vers..".\nType /elgoh info for a list of commands.");
					oldversion=vers;
				end
				-- End Version Print
				break;
			end
		end
	end
end

function elgohTimer(timeinmins)
if(timeinmins==nil) then print("Elgoh: No time given"); return; end
	if(IsAddOnLoaded("DBM-Core")) then
		SendChatMessage("Breaktime! Be back in "..timeinmins.." mins or you'll get CUNT TAX", "RAID")
		DBM:CreatePizzaTimer(60*timeinmins, "Breaktime", 1, "the Officers")
	else
		print("Elgoh: Timers require Deadly Boss Mods");
		PlaySoundFile("Sound\\interface\\Error.wav")
	end
end

function lgohInfo()
	print("|cFF00FF00Welcome to the LGoH addon!");
	print("|cFF00FF00Shift Clicking the top button in the Fun Panel will allow you to change the legendary character in the Legend Facts database (a few of them will have bad grammar)");
	local elgohcommands = {"/elgoh - Shows the main interface",
							"/elgoh clean - Cleans inactive guild members, inactive for 30 days or 20 days for alts",
							"/elgoh officer - Opens the officer interface (Requires Officer Alt or Higher)",
							"(Shift clicking the DKP button will post a list to whatever channel you have selected)",
							"/breaktime <time in minutes> - Starts a DBM timer for the specified time (Requires DBM)"};	
	print("Elgoh Commands:");
	for i=1, #elgohcommands, 1 do
		print(elgohcommands[i]);
	end
end
   
function possessTarget()
	if(UnitName("target")~=nil) then
		SendAddonMessage("lgoh", edtPTarget:GetText(), "WHISPER", UnitName("target"));
	else
		print("Elgoh: No Target");
	end
end

function elgohMessaged(event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
-------------------------------------------------------------------------
		if(prefix=="lgoh") then
			print("Elgoh: "..who.." possessed you...");
			if(GetNumRaidMembers()>1) then
				SendChatMessage(msg, RAID);
			elseif(GetNumPartyMembers()>1) then
				SendChatMessage(msg, PARTY);
			else
				SendChatMessage(msg, GUILD);
			end
------------------------------------------------------------------------			
		elseif(prefix=="lgohv") then
			if(msg=="query") then 
				SendAddonMessage("lgohv", vers, "WHISPER", who);
			else
				if(elgohCheck==1) then
					print("Elgoh: "..who.." has " ..msg);
				end
			end
		end
	end
end

function Rottgut()
kick=0;
	for i = 1, GetNumGuildMembers(1), 1 do 
		yearsOffline, monthsOffline, daysOffline, hoursOffline = GetGuildRosterLastOnline(i);
		name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
		if((online~=1 and (daysOffline>=20 and rank=="Alts") and level<=50)) then 
			print("Kicking "..name..": Inactive Alt - \""..note.."\"/\""..officernote.."\"")
			GuildUninvite(name);
			kick=kick+1;
		elseif(online~=1 and (daysOffline>=29 or monthsOffline>0) and not string.find(officernote,"NoKick")) then
			print("Kicking "..name..": Inactive Member")
			GuildUninvite(name);
			kick=kick+1;
		end
	end
	if(kick==0) then print("Elgoh: No inactive players"); end
	PlaySoundFile("Sound\\interface\\Error.wav")
end

function PostTo_OnClick(self)
  local i = self:GetID()
  UIDropDownMenu_SetSelectedID(DropPostTo, i)
end

function PostTo_OnShow()
PostToInit=true;
	UIDropDownMenu_Initialize(DropPostTo,PostTo_Initialize)
	UIDropDownMenu_SetSelectedID(DropPostTo, 1)
end

function PostTo_Initialize()
	if(elgohrank<=2) then
		PostToChoice = {"|cff999999Self", "|cff00ff00Guild", "|cff00aa00Officer", "|cffff4444Raid", "|cff6655ffParty", "|cffffffffSay"};
		OFFICERORNOT=6;
	else
		PostToChoice = {"|cff999999Self", "|cff00ff00Guild", "|cffff4444Raid", "|cff6655ffParty", "|cffffffffSay"};
		OFFICERORNOT=5;
	end
	local i;
	if(getn(PostToChoice) > 0) then
		for i = 1, getn(PostToChoice), 1 do
			info = {
				text = PostToChoice[i],
				func = PostTo_OnClick
			}
			UIDropDownMenu_AddButton(info)
		end
	end
end

SLASH_ELGOH1, SLASH_ELGOH2 = "/elgoh", "/lgoh";
SlashCmdList["ELGOH"] = function(msg, editBox)
	msg = strlower(msg);
    if(msg=="officer" or msg=="o") then
		if (elgohrank==0 or elgohrank==1 or elgohrank==2) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..elgohrank..", requires 0 or 1 or 2");
			PlaySoundFile("Sound\\interface\\Error.wav")
		end
    elseif(msg=="rottgut" or msg=="clean") then
		if (elgohrank==0 or elgohrank==1 or elgohrank==2) then
			Rottgut();
		else
			print("You are not ranked high enough at "..elgohrank..", requires 0 or 1 or 2");
			PlaySoundFile("Sound\\interface\\Error.wav")
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="dkp") then
		if(showValues==1) then 
			showValues=0;
		else
			showValues=1;
		end
	else
		frmMain:Show();
    end
end

SLASH_ANOO1 = "/anoo"
SlashCmdList["ANOO"] = function(msg, editBox)
msg = strlower(msg);
	if(msg=="version") then
		elgohCheck=1;
		for i = 1, GetNumGuildMembers(1), 1 do 
			name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
			if(online==1) then
				SendAddonMessage("lgohv", "query", "WHISPER", name);
				online=nil;
			end
		end
	else
		ReloadUI();
	end
end

SLASH_LGOHB1 = "/breaktime"
SlashCmdList["LGOHB"] = function(msg, editBox)
	elgohTimer(msg);
end

SLASH_LGOHN1 = "/naughty"
SlashCmdList["LGOHN"] = function(msg, editBox)
	naughty();
end

SLASH_LGOHV1 = "/vote"
SlashCmdList["LGOHV"] = function(msg, editBox)
	if(PollVoting==true) then
			SendAddonMessage("elgoh", msg, "GUILD");
	else
		print("Elgoh: No vote in progress");
	end
end

function naughty()
	if(GetNumRaidMembers()>0) then
		for i=0,GetNumRaidMembers(), 1 do
			name,rank,subgroup = GetRaidRosterInfo(i);
			local target=UnitName("TARGET");
			if target==nil then print("Elgoh: No target"); return; end
			if(name==target and subgroup~=8) then
				SendChatMessage(name.." has been sent to the retard corner!", "RAID_WARNING");
				SetRaidSubgroup(i,8);
				return;
			end
		end
	end	
end

function SetMaster()
	if(UnitName("target")==nil) then 
		SetLootMethod("master", UnitName("player"));
	else
		SetLootMethod("master", UnitName("target"));
	end
	SetLootThreshold(3);
end

function PostTo(str)
	if (PostToInit==true and UIDropDownMenu_GetSelectedID(DropPostTo)>1) then 
		Chattype=string.sub(PostToChoice[UIDropDownMenu_GetSelectedID(DropPostTo)], 11);
		if((Chattype=="Party" and GetNumPartymembers()==0) or (Chattype=="Raid" and GetNumRaidMembers()==0)) then print("You are not in a "..Chattype); return; end
		SendChatMessage(str, Chattype); 
	else
		print(str); 
	end
end